//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

//  ,      
//  
bool doubled (int elem1, int elem2)
{
 return elem1 * 2 == elem2;
}

int main()
{
  vector<int> coll;

  coll.push_back(1);
  coll.push_back(3);
  coll.push_back(2);
  coll.push_back(4);
  coll.push_back(5);
  coll.push_back(5);
  coll.push_back(0);

  PRINT_ELEMENTS(coll,":\n");

  //       
  vector<int>::iterator pos;
  pos = adjacent_find (coll.begin(), coll.end());
  if (pos != coll.end()) {
      cout << ToRus("       \n")
           << distance(coll.begin(),pos) + 1
           << ToRus(" .") << endl;
  }

  //    ,    
  //    
  pos = adjacent_find (coll.begin(), coll.end(),   // 
                       doubled);                   // 

  if (pos != coll.end()) {
      cout << ToRus("  ,    \n")
           << ToRus("   ,  \n")
           << distance(coll.begin(),pos) + 1
           << ToRus(" .") << endl;
   }


  getch();
  return 0;
}

//---------------------------------------------------------------------------